import java.util.function.DoubleToIntFunction;

/**
 * it provides information of students of an indivisual Class
 * @author AliAsad
 * @version 1.0
 */
public class Class {
    // each student is an object these objects are stored here
    private Student[] students;
    // average of students grades
    private double avg;
    // day of Class
    private String day;
    // capacity of Class
    private int capacity;
    // the filled capacity of Class
    private int currentSize ;
    private String master ;
    private String className;

    /**
     * @param cap the capacity of Class
     * @param d the day of Class
     */
    public Class(int cap, String d,String master,String className) {
        capacity = cap;
        day = d;
        students = new  Student[capacity];
        this.master = master ;
        this.className = className;
        currentSize = 0 ;
    }

    /**
     * gives student and adds to students array
     * @param std the student that will be added
     */
    public void enrollStudent(Student std) {
        if (currentSize < capacity) {
            students[currentSize] = std;
            currentSize++;
        } else {
            System.out.println("Lab is full!!!");
        }
    }

    /**
     * prints the Class information
     */
    public void print() {
        calculateAvg();
        System.out.println("Information of class "+getClassName());
        System.out.println("Master : "+ getMaster()+"\n"+"Students :");
        for (int i = 0 ; i < currentSize ;i++)
        System.out.println(students[i].getFirstName() +" "+ students[i].getLastName()+", student ID: "
                + students[i].getId() + ", grade: " + students[i].getGrade());
        System.out.println("avg :" + avg);
    }

    /**
     * get the students array
     * @return students array
     */
    public Student[] getStudents() {
        return  students;
    }

    /**
     * set the students
     * @param students the new students that will be added
     */
    public void setStudents(Student[] students) {
        this.students = students;
    }

    /**
     * get the avg
     * @return avg
     */
    public double getAvg() {
        return avg;
    }

    /**
     * calculate the avg of students grades
     */
    public void calculateAvg() {
        int sum = 0 ;
        for (int  i = 0 ; i < currentSize  ; i++ )
            sum += students[i].getGrade();
        avg = sum / currentSize;
    }

    /**
     * get the name of Class
     * @return className
     */
    public String getClassName() {
        return className;
    }

    /**
     * set the name of Class
     * @param  className
     */
    public void setClassName(String className) {
        this.className = className;
    }

    /**
     * get the master of Class
     * @return master
     */
    public String getMaster() {
        return master;
    }

    /**
     * set the master of Class
     * @param master new master
     */
    public void setMaster(String master) {
        this.master = master;
    }

    /**
     * get the day of Class
     * @return day
     */
    public String getDay() {
        return day;
    }

    /**
     * set the day of Class
     * @param day new day
     */
    public void setDay(String day) {
        this.day = day;
    }

    /**
     * get the capacity of Class
     * @return capacity
     */
    public int getCapacity() {
        return capacity;
    }

    /**
     * set the Class capacity
     * @param capacity the new capacity
     */
    public void setCapacity(int capacity) {
        this.capacity = capacity;
    }
}