import java.util.*;
/**
 * The Master class represents a Master in a Master
 administration system.
 * It holds the Master details relevant in our context.
 *
 * @author AliAsad
 * @version 1.0
 */

public class Master {
    // the Master’s first name
    private String firstName;
    // the Master’s last name
    private String lastName;
    // the Master ID
    private String id;
    //the room number of the Master
    private int roomNum;


    /**
     * Create a new Master with a given name and ID number.
     *
     * @param fName first name of Master
     * @param lname last name of Master
     * @param mID Master ID
     */
    public Master(String fName, String lname, String mID){
        firstName = fName;
        lastName = lname;
        id = mID;
    }

    /**
     * set the roomNum of Master
     * @param newRoomNum new roomNum of the Master
     */
    public void setRoomNum(int newRoomNum){
        if(newRoomNum <= 500 && newRoomNum >= 0 )
            roomNum = newRoomNum;
    }
    /**
     * get the RoomNum of Master
     * @return RoomNum field
     */
    public  int getRoomNum(){
        return  roomNum;
    }
    /**
     * set the id of Master
     * @param newId new id of Master
     */
    public void setId(String newId){
        id = newId;
    }
    /**
     * get the ID of Master
     * @return id field
     */
    public  String getId(){
        return  id;
    }
    /**
     * get the firstName of Master
     * @return firstName field
     */
    public String getFirstName() {
        return firstName;
    }
    /**
     * get the lastName of Master
     * @return lastName field
     */
    public String getLastName() {
        return lastName;
    }

    /**
     * set the firstName of Master
     * @param fName first name of Master
     */
    public void setFirstName(String fName) {
        firstName = fName;
    }

    /**
     * prints the information of each Master
     */
    public void print() {
        System.out.println(lastName + ", Master ID: "
                + id + ", RoomNumber: " + roomNum);
    }
}